package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.PortalPage;
import com.sa.ibiz.demo.demo.service.PortalPageService;
import com.sa.ibiz.demo.demo.service.dto.PortalPageSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/portalpage")
public class PortalPageResource
{
	@Autowired
	private PortalPageService service;


	@PostMapping(value = "/create")
	public ResponseEntity<PortalPage> create(@Validated @RequestBody PortalPage data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("门户页面[create]操作发生错误","PortalPage",data.getPortalpageid().toString());
		return ResponseEntity.ok().body(data);
	}
	@GetMapping(value = "/{id}")
	public ResponseEntity<PortalPage> get(@Validated @PathVariable String id){
		PortalPage data=new PortalPage();
		data.setPortalpageid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("门户页面[get]操作发生错误","PortalPage",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<PortalPage> checkKey(@Validated @RequestBody PortalPage data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("门户页面[checkKey]操作发生错误","PortalPage",data.getPortalpageid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<PortalPage> getDraft(@Validated @RequestBody PortalPage data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("门户页面[getDraft]操作发生错误","PortalPage","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<PortalPage> remove(@Validated @RequestBody PortalPage data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("门户页面[remove]操作发生错误","PortalPage",data.getPortalpageid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<PortalPage> update(@Validated @RequestBody PortalPage data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("门户页面[update]操作发生错误","PortalPage",data.getPortalpageid().toString());
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<PortalPage>> searchDefaultPage(@Validated @RequestBody PortalPageSearchFilter filter){
		Page<PortalPage> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<PortalPage>> listDefault(@Validated @RequestBody PortalPageSearchFilter filter){
		List<PortalPage> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
